/*
 *  CPMacros.h
 *  CPCore
 *
 *  Created by Brad Miller on 11/20/05.
 *  Copyright 2005 CynicalPeak. All rights reserved.
 *
 */

#import "CPDebug.h"
#import "CPMethodLogger.h"

// NSLog replacements
#define CPLog(s, ...) [[CPDebug standardDebug] logFile:__FILE__ lineNumber:__LINE__  logLevel:CPDebugDebug format:(s),##__VA_ARGS__]
#define CPLogError(s, ...) [[CPDebug standardDebug] logFile:__FILE__ lineNumber:__LINE__  logLevel:CPDebugError format:(s),##__VA_ARGS__]
#define CPLogWarning(s, ...) [[CPDebug standardDebug] logFile:__FILE__ lineNumber:__LINE__  logLevel:CPDebugWarning format:(s),##__VA_ARGS__]
#define CPLogAlert(s, ...) [[CPDebug standardDebug] logFile:__FILE__ lineNumber:__LINE__  logLevel:CPDebugAlert format:(s),##__VA_ARGS__]
#define CPLogCritical(s, ...) [[CPDebug standardDebug] logFile:__FILE__ lineNumber:__LINE__  logLevel:CPDebugCritical format:(s),##__VA_ARGS__]
#define CPLogEmergency(s, ...) [[CPDebug standardDebug] logFile:__FILE__ lineNumber:__LINE__  logLevel:CPDebugEmergency format:(s),##__VA_ARGS__]

#define CPLogInfo(s, ...) [[CPDebug standardDebug] logFile:__FILE__ lineNumber:__LINE__  logLevel:CPDebugInfo format:(s),##__VA_ARGS__]
#define CPLogNotice(s, ...) [[CPDebug standardDebug] logFile:__FILE__ lineNumber:__LINE__  logLevel:CPDebugNotice format:(s),##__VA_ARGS__]

#define CPTrace CPMethodLogger *CPMETHODLOGGEROBJECT KBScopeReleased = [[CPMethodLogger alloc] initWithMethodSignature:__PRETTY_FUNCTION__ format:nil]
#define CPTraceLog(s, ...) CPMethodLogger *CPMETHODLOGGEROBJECT KBScopeReleased = [[CPMethodLogger alloc] initWithMethodSignature:__PRETTY_FUNCTION__ format:(s),##__VA_ARGS__]
#define CPTimedTrace CPMethodLogger *CPMETHODLOGGEROBJECT KBScopeReleased = [[CPMethodLogger alloc] initWithTimedMethodSignature:__PRETTY_FUNCTION__ format:nil]
#define CPTimedTraceLog(s, ...) CPMethodLogger *CPMETHODLOGGEROBJECT KBScopeReleased = [[CPMethodLogger alloc] initWithTimedMethodSignature:__PRETTY_FUNCTION__ format:(s),##__VA_ARGS__]

#define CPTimerStart()	[[CPDebug standardDebug] startTimer:1];
#define CPTimerEnd(s)	[[CPDebug standardDebug] endTimer:1 file:__FILE__ lineNumber:__LINE__ message:s];

#define CPTimer2Start()	[[CPDebug standardDebug] startTimer:2];
#define CPTimer2End(s)	[[CPDebug standardDebug] endTimer:2 file:__FILE__ lineNumber:__LINE__ message:s];

#define CPTimer3Start()	[[CPDebug standardDebug] startTimer:3];
#define CPTimer3End(s)	[[CPDebug standardDebug] endTimer:3 file:__FILE__ lineNumber:__LINE__ message:s];

#define CPTimer4Start()	[[CPDebug standardDebug] startTimer:4];
#define CPTimer4End(s)	[[CPDebug standardDebug] endTimer:4 file:__FILE__ lineNumber:__LINE__ message:s];

#define CPTimer5Start()	[[CPDebug standardDebug] startTimer:5];
#define CPTimer5End(s)	[[CPDebug standardDebug] endTimer:5 file:__FILE__ lineNumber:__LINE__ message:s];
